(*  Title:   ~~~/isac/smltest/Pure/General/Basics.thy
    Author: Walther Neuper, TU Graz

$ cd /usr/local/Isabelle2009-1/src/Pure/isac/smltest/Pure/General
$ /usr/local/isabisac/bin/isabelle emacs Scan.thy &
*)

header {* testing combinators from src/Pure/General/basics 
          see *}

theory Basics
imports Complex_Main
begin

ML {* op |> ;
  1 |> (fn x => x+10)
    |> (fn x => 2*x);
(*val it = 22 : int*)
*}

ML {* op |-> ;
  fun ff c a = a + c;
  (10, 1) |-> ff
(*val it = 11 : int*)
*}

ML {* op |>> ;
  (1, "a") |>> (fn x => x+10)
(*val it = (11, "a") : int * string*)
*}

ML {* op ||> ;
  ("a", 1) ||> (fn x => x+10)
(*val it = ("a", 11) : string * int*)
*}

end

